#pragma interface
#ifndef TLMPWEB_H
#define TLMPWEB_H

#include <misc.h>
#include <time.h>

// Runtime for .hc pages

#define _TLMP_frame2

struct _F_frame2{
	#define _F_frame2_top(x) void x top ()
	virtual _F_frame2_top( )=0;
	#define _F_frame2_bottom(x) void x bottom ()
	virtual _F_frame2_bottom( )=0;
};

#define _TLMP_frame4

struct _F_frame4{
	#define _F_frame4_left(x) void x left ()
	virtual _F_frame4_left( )=0;
	#define _F_frame4_top(x) void x top ()
	virtual _F_frame4_top( )=0;
	#define _F_frame4_body(x) void x body ()
	virtual _F_frame4_body( )=0;
	#define _F_frame4_top_left(x) void x top_left ()
	virtual _F_frame4_top_left( )=0;
};

#define _TLMP_frame3

struct _F_frame3{
	#define _F_frame3_left(x) void x left ()
	virtual _F_frame3_left( )=0;
	#define _F_frame3_top(x) void x top ()
	virtual _F_frame3_top( )=0;
	#define _F_frame3_body(x) void x body ()
	virtual _F_frame3_body( )=0;
};

#define _TLMP_vmenu

struct _F_vmenu{
	#define _F_vmenu_intro(x) void x intro()
	virtual _F_vmenu_intro( )=0;
	#define _F_vmenu_mailing(x) void x mailing()
	virtual _F_vmenu_mailing( )=0;
	#define _F_vmenu_download(x) void x download()
	virtual _F_vmenu_download( )=0;
	#define _F_vmenu_doc(x) void x doc()
	virtual _F_vmenu_doc( ) = 0;
	#define _F_vmenu_changes(x) void x changes()
	virtual _F_vmenu_changes( )=0;
	#define _F_vmenu_news(x) void x news()
	virtual _F_vmenu_news( )=0;
};

#define _TLMP_hmenu

struct _F_hmenu{
	#define _F_hmenu_home(x) void x home()
	virtual _F_hmenu_home( )=0;
	#define _F_hmenu_search(x) void x search()
	virtual _F_hmenu_search( )=0;
};


#define _TLMP_form

struct _F_form{
	// We can add as much info in priv without losing the  binary
	// compatibility
public:
	struct _F_form_private *priv;
	/*~PROTOBEG~ _F_form */
public:
	_F_form (void);
	void field_checkbox (const char *name,
		 bool selected,
		 const char *opt);
	void field_hidden (const char *name,
		 const char *value);
	void field_list (const char *name,
		 const char *value,
		 const char *opt);
	void field_list_end (void);
	void field_list_item (const char *sel_value);
	void field_list_item (const char *sel_value,
		 const char *sel_desc);
	void field_radio (const char *name,
		 const char *value,
		 bool selected,
		 const char *opt);
	void field_string (const char *name,
		 const char *value,
		 const char *opt);
	void field_textarea (const char *name,
		 int rows,
		 int cols,
		 const char *opt);
	void field_textarea_body (const char *ctl, ...);
	void field_textarea_end (void);
	void fputs (const char *s, FILE *f);
	void printf (const char *ctl, ...);
	void setfield (const char *name,
		 const char *type,
		 const char *value,
		 const char *opt);
	/*~PROTOEND~ _F_form */
	#define _F_form_setup(x) void x setup(bool first)
	virtual _F_form_setup( ) = 0;
	#define _F_form_validate(x) bool x validate()
	virtual _F_form_validate( ) = 0;
	#define _F_form_process(x) void x process()
	virtual _F_form_process( ) = 0;
};

class W_VAR{
protected:
	bool was_set;
	const char *name;
	W_VAR *next;
public:
	virtual void setinitval (const char *val)=0;
	/*~PROTOBEG~ W_VAR */
public:
	W_VAR (const char *_name);
	const char *getname (void);
	W_VAR *getnext (void)const;
	bool isset (void);
	virtual ~W_VAR (void);
	/*~PROTOEND~ W_VAR */
};

class W_SSTRING: public SSTRING, public W_VAR{
	/*~PROTOBEG~ W_SSTRING */
public:
	W_SSTRING (const char *_name);
	void setinitval (const char *v);
	/*~PROTOEND~ W_SSTRING */
};

class W_INT: public W_VAR{
	int val;
	/*~PROTOBEG~ W_INT */
public:
	W_INT (const char *_name);
	W_INT&operator = (int v);
	operator int (void);
	void setinitval (const char *v);
	/*~PROTOEND~ W_INT */
};

class URL_ENCODE{
	SSTRINGS tb;
	/*~PROTOBEG~ URL_ENCODE */
public:
	URL_ENCODE (void);
	const char *enc (const SSTRING&s);
	const char *enc (const char *s);
	/*~PROTOEND~ URL_ENCODE */
};
	
#define _TLMP_websession

struct _F_websession{
	void setrealm(const char *realm);
	#define _F_websession_auth(nom) int nom auth()
	virtual _F_websession_auth( )=0;
	#define _F_websession_logged(nom) int nom logged()
	virtual _F_websession_logged( )=0;
	#define _F_websession_save(nom) int nom save()
	virtual _F_websession_save( );
	#define _F_websession_load(nom) int nom load()
	virtual _F_websession_load( );
};

#define _TLMP_websteps

struct _F_websteps{
	class websteps_private *priv;
	void gotostep(int step);
	#define _F_websteps_step1(nom) void nom step1()
	virtual _F_websteps_step1( )=0;
	#define _F_websteps_step2(nom) void nom step2()
	virtual _F_websteps_step2( )=0;
	#define _F_websteps_step3(nom) void nom step3()
	virtual _F_websteps_step3( );
	#define _F_websteps_step4(nom) void nom step4()
	virtual _F_websteps_step4( );
	#define _F_websteps_step5(nom) void nom step5()
	virtual _F_websteps_step5( );
	#define _F_websteps_step6(nom) void nom step6()
	virtual _F_websteps_step6( );
	#define _F_websteps_step7(nom) void nom step7()
	virtual _F_websteps_step7( );
	#define _F_websteps_step8(nom) void nom step8()
	virtual _F_websteps_step8( );
	#define _F_websteps_step9(nom) void nom step9()
	virtual _F_websteps_step9( );
};



#include "tlmpweb.p"

#endif

