#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <misc.h>
#include "tlmpweb.h"

static W_VAR *first;

void wvar_init()
{
	W_VAR *pt = first;
	while (pt != NULL){
		if (!pt->isset()){	
			bool is_def;
			const char *val = t_varstr (pt->getname(),is_def);
			if (is_def) pt->setinitval (val);
		}
		pt = pt->getnext();
	}
}

PUBLIC W_VAR::W_VAR(const char *_name)
{
	name = strdup(_name);
	next = first;
	first = this;
	was_set = false;
}

PUBLIC VIRTUAL W_VAR::~W_VAR()
{
	free ((char*)name);
}

PUBLIC W_VAR * W_VAR::getnext() const
{
	return next;
}
/*
	Return true if the variable was initialised (was supplied by the request)
*/
PUBLIC bool W_VAR::isset()
{
	return was_set;
}
	

PUBLIC const char *W_VAR::getname()
{
	return name;
}

PUBLIC W_SSTRING::W_SSTRING(const char *_name)
	: SSTRING(), W_VAR(_name)
{
}

PUBLIC void W_SSTRING::setinitval(const char *v)
{
	setfrom (v);
	was_set = true;
}

PUBLIC W_INT::W_INT(const char *_name)
	: W_VAR (_name)
{
	val = 0;
}

PUBLIC void W_INT::setinitval(const char *v)
{
	if (isdigit(v[0])){
		was_set = true;
		val = atoi(v);
	}
}

PUBLIC  W_INT::operator int()
{
	return val;
}

PUBLIC W_INT & W_INT::operator =(int v)
{
	val = v;
	return *this;
}

